//+------------------------------------------------------------------+
//|                                                   MACD_MA_EA.mq4 |
//|                      Copyright  2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//---- input parameters
extern string Developer        ="LEO N. RILLERA ";
extern string EmailAd          ="newlink_leo@yahoo.com.";
extern double TakeProfit       =500;
extern double StopLoss         =300;
extern double MACDOpenLevel    =3;
extern double MACDCloseLevel   =2;
extern double MACD1            =10;
extern double MACD2            =16;
extern double MACD3            =2;
extern double MATrendPeriod    =20;
extern double Lots             =0.01;
extern int    MagicNumber      =1000;
extern bool      TrailingOn    = true;
extern int       TrailStartB   = 0;
extern int       TrailStartS   = 0;
extern double    TrailingStop  = 300;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   double p=Point;
   double MacdCurrent, MacdPrevious, SignalCurrent,SignalPrevious;
   double MaCurrent, MaPrevious;
  
   int     OrdersPerSymbol=0;
   int     cnt=0;
//+----------------------------------------------------------------------------+
//| Please do not modify beyond this area if you do not know about programming |
//+----------------------------------------------------------------------------+
   if(AccountFreeMargin()<(1000*Lots))    {Print("Kurang Kuwartam"); return(0);}
   if(Bars<100)                           {Print("-----NO BARS "); return(0);}
   
   MacdCurrent=iMACD(NULL,0,MACD1,MACD2,MACD3,PRICE_CLOSE,MODE_MAIN,0);
   MacdPrevious=iMACD(NULL,0,MACD1,MACD2,MACD3,PRICE_CLOSE,MODE_MAIN,1);
   SignalCurrent=iMACD(NULL,0,MACD1,MACD2,MACD3,PRICE_CLOSE,MODE_SIGNAL,0);
   SignalPrevious=iMACD(NULL,0,MACD1,MACD2,MACD3,PRICE_CLOSE,MODE_SIGNAL,1);
   MaCurrent=iMA(NULL,0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,0);
   MaPrevious=iMA(NULL,0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,1);
  
      
    int Total = OrdersTotal();      
    int ManoGatangem  = 0;                   
    int Ticket        = 0;                   
    int ManoLakom     = 0;                    
    int Daan          = 0;                    
    int Dati          = 0;             
      
    int TypeOrd       = -1;                   
    int i;                                
    double Baro  = 0;          
    double Tabbed;       

    
    for(i=0;i<Total;i++) 
    { 
    OrderSelect(i,SELECT_BY_POS,MODE_TRADES);          
    if ((OrderSymbol()==Symbol()) && (OrderMagicNumber()==MagicNumber)) 
    {
    
           Daan = OrderProfit() / Point;         
           Baro = 0;       
           if (OrderType()==OP_BUY) 
           {         
               ManoGatangem++; 
               if (TrailingOn) 
               {           
               Dati = (OrderClosePrice()-OrderStopLoss())/Point;           
                if ((Daan>TrailingStop) && (Dati>TrailingStop)&&(Bid-OrderOpenPrice()>TrailStartB*Point))
                Baro = (Bid - TrailingStop*Point);         
                }
            }        
            if (OrderType()==OP_SELL) 
            {
                     ManoLakom++;
                      if (TrailingOn) 
                      {           
                                 Dati = (OrderStopLoss()-OrderClosePrice())/Point;
                                 if ((Daan>TrailingStop) && (Dati>TrailingStop)&&(OrderOpenPrice()-Ask >TrailStartS*Point))
                                 Baro = (Ask + TrailingStop*Point);         
                       }        
             }        
             if (Baro>0) 
             {
                      OrderModify(OrderTicket(), OrderOpenPrice(),Baro,OrderTakeProfit(), 0,Red);
              }      
         }    
    }
   
   
   
   //   
   OrdersPerSymbol=0;
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol() )
        {
         OrdersPerSymbol++;
        }
     }
   if(OrdersPerSymbol<1)
     {
     
      if(MacdCurrent<0 && MacdCurrent>SignalCurrent && MacdPrevious<SignalPrevious &&
         MathAbs(MacdCurrent)>(MACDOpenLevel*p) && MaCurrent>MaPrevious)
		  {
         OrderSend(Symbol(),OP_BUY,Lots,Ask,0,Ask-(StopLoss*p),Ask+(TakeProfit*p),"Gumatang kan a"+CurTime(),MagicNumber,0,White);
         return(0);
        }
        
        
      if(MacdCurrent>0 && MacdCurrent<SignalCurrent && MacdPrevious>SignalPrevious && 
         MacdCurrent>(MACDOpenLevel*p) && MaCurrent<MaPrevious)
        {
         OrderSend(Symbol(),OP_SELL,Lots,Bid,0,Bid+(StopLoss*p),Bid-(TakeProfit*p),"Aglako kan a"+CurTime(),MagicNumber,0,Red);
         return(0);
        }
     }
        for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol() )
        {
         if(OrderType()==OP_BUY)
           {
            if(MacdCurrent>0 && MacdCurrent<SignalCurrent && MacdPrevious>SignalPrevious &&
               MacdCurrent>(MACDCloseLevel*Point))
              {
               OrderClose(OrderTicket(),Lots,Bid,0,White);
              }
           } // if BUY


         if(OrderType()==OP_SELL)
           {
            if(MacdCurrent<0 && MacdCurrent>SignalCurrent &&
               MacdPrevious<SignalPrevious && MathAbs(MacdCurrent)>(MACDCloseLevel*Point))
              {
               OrderClose(OrderTicket(),Lots,Ask,0,Red);
              }
           } //if SELL
           
        } // if(OrderSymbol)
        
     } // for



   return(0);
  }
//+------------------------------------------------------------------+